from abc import ABC, abstractmethod
from typing import Callable

from cpl_query.extension import List
from discord.ext.commands import Context

from bot_data.model.user import User


class ClientUtilsServiceABC(ABC):

    @abstractmethod
    def __init__(self): pass

    @abstractmethod
    def received_command(self, guild_id: int): pass

    @abstractmethod
    def moved_user(self, guild_id: int): pass

    @abstractmethod
    def moved_users(self, guild_id: int, count: int): pass

    @abstractmethod
    def get_client(self, dc_ic: int, guild_id: int): pass

    @abstractmethod
    async def check_if_bot_is_ready_yet(self) -> bool: pass

    @abstractmethod
    async def check_if_bot_is_ready_yet_and_respond(self, ctx: Context) -> bool: pass

    @abstractmethod
    async def presence_game(self, t_key: str): pass

    @abstractmethod
    def get_auto_complete_list(self, _l: List, current: str, select: Callable = None) -> List: pass

    @abstractmethod
    def get_ontime_for_user(self, user: User) -> float: pass
